/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378 ļϵͳӳ(EXAM7)
*                      USB Host File Interface for CH378
*					   TC2.0@PC, KC7.0@MCS51
*******************************************************************************/



/******************************************************************************
˵: 
    MCS-51ƬCԵUļдʾ
    ʾֽڷʽд,޸ļ,ѯʣռ,
    ʾֽڶд,ڽADCģɼӵU̻SDļMY_ADC.TXT,
    ļôӵļĩβ,ļô½ļ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include <reg52.h>
#include <stdio.h>
#include <string.h>
#include "CH378INC.H"											 /* CH378ͷļ */	
#include "HAL.H"												 /* Ӳͷļ */
#include "HAL_BASE.C"											 /* Ӳӳļ */
#include "DEBUG.H"												 /* ӳͷļ */
#include "DEBUG.C"												 /* ӳļ */

/*******************************************************************************/
/* ѡͨѶӿ */
#define	IC_OP_INTERFACE_MODE	 2							 	 /* оƬӿģʽ(1:Ӳ;  2:ģⲢ; 
                                                                    	                 3:ӲSPI; 4:ģSPI; 5:첽) */                                                                    
#if    ( IC_OP_INTERFACE_MODE == 1 )
#include "PARA_HW.C"											 /* Ӳ߲ӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 2 )
#include "PARA_SW.C"										 	 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
#include "SPI_HW.C"										 	 	 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
#include "SPI_SW.C"												 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
#include "UART_HW.C"										 	 /* Ӳ첽ӷʽ */
#else
#error: You Must Include Right Interface Operate File!!!
#endif

/*******************************************************************************/
/* ѡҪĺ */
//#define EN_DISK_QUERY		  	   1							 /* ѯʣռѯӳ */
//#define EN_DIR_CREATE			   1							 /* ½༶Ŀ¼ӳ */	
//#define EN_SECTOR_ACCESS     	   1							 /* Ϊλдļӳ */		
//#define EN_LONG_NAME	   		   1							 /* ֳ֧ļӳ */		
//#define EN_OTHER_FUNCTION   	   1							 /* ǳӳ */		

#include "FILE_SYS.H"											 /* ļϵͳͷļ */
#include "FILE_SYS.C"											 /* ļϵͳӳļ */

/*******************************************************************************/
/*  */
UINT16 SecterSize;												 /* ǰUÿС */  
UINT8  xdata buf[ 64 ];											 /* ݻ */	

/*******************************************************************************
* Function Name  : main
* Description    : 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void main( void ) 
{
	UINT8  status, len;
	UINT16 i;
	UINT8  month, date, hour;
	UINT16 adc;
		
	mDelaymS( 100 );  											 /* ʱ100 */
	mInitSTDIO( );  											 /* Ϊüͨڼʾ */

#if    ( IC_OP_INTERFACE_MODE == 1 )
	printf(" MCS51_CH378_PARA_HW V1.2 2015.08.28...\n");		 /* Ӳ߲ӷʽ */						 			 
#elif  ( IC_OP_INTERFACE_MODE == 2 )
	printf(" MCS51_CH378_PARA_SW V1.2 2015.08.28...\n"); 		 /* ģⲢӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 3 )
	printf(" MCS51_CH378_SPI_HW V1.2 2015.08.28...\n"); 		 /* ӲSPIӷʽ */
#elif  ( IC_OP_INTERFACE_MODE == 4 )
	printf(" MCS51_CH378_SPI_SW V1.2 2015.08.28...\n");			 /* ģSPIʽ */
#elif  ( IC_OP_INTERFACE_MODE == 5 )
	printf(" MCS51_CH378_UART_HW V1.2 2015.08.28...\n");		 /* Ӳ첽ӷʽ */
#else
	printf(" MCS51_CH378_INTERFACE ERROR 2015.08.28...\n");
#endif

	printf( "Start\n" );
	mDelaymS( 200 );

	status = mInitCH378Host( );  								 /* ʼCH378 */								 	
	mStopIfError( status );
	/* ·ʼ */

	while( 1 ) 													 
	{
		/* U̻SDǷ,ȴ */
		printf( "Wait Udisk/SD\n" );
		while( CH378DiskConnect( ) != ERR_SUCCESS ) 
		{  
			mDelaymS( 100 );
		}
		mDelaymS( 200 );  										 /* ʱ,ѡ,еUSB洢Ҫʮʱ */
		
		/* ڼ⵽USB豸,ȴ100*50mS,ҪЩMP3̫,ڼ⵽USB豸DISK_MOUNTED,
		   ȴ5*50mS,ҪDiskReady */
		for( i = 0; i < 100; i ++ ) 
		{  
			/* ȴʱ,100*50mS */
			mDelaymS( 50 );
			printf( "Ready ?\n" );
			status = CH378DiskReady( );  						 /* ʼ̲ԴǷ */
			if( status == ERR_SUCCESS ) 
			{
				break;  										 /* ׼ */
			}
			else if( status == ERR_DISK_DISCON ) 
			{
				goto UnknownUsbDevice; 							 /* ⵽Ͽ,¼Ⲣʱ */
			}
			if( CH378GetDiskStatus( ) >= DEF_DISK_MOUNTED && i >= 5 ) 
			{
				break;  										 /* еUǷδ׼,Ժ,ֻҪ佨MOUNTEDҳ5*50mS */
			}
		}
		if( status == ERR_DISK_DISCON ) 
		{  
			/* ⵽Ͽ,¼Ⲣʱ */
			printf( "Device gone\n" );
			continue;
		}
		if( CH378GetDiskStatus( ) < DEF_DISK_MOUNTED ) 
		{  
			/* δ֪USB豸,USB̡ӡ */
			printf( "Unknown device\n" );
			goto UnknownUsbDevice;
		}
		
		/* Ҫ,ԶȡݿCH378_CMD_DATA.DiskMountInq,س */
		i = CH378ReadReqBlock( buf );
		if( i == sizeof( INQUIRY_DATA ) ) 
		{  
			/* U̵ĳ̺ͲƷϢ */
			buf[ i ] = 0;
			printf( "Udisk Info: %s\n", ((P_INQUIRY_DATA)buf) -> VendorIdStr );
		}

		/* ȡǰUС(Ҫʹ) */
		SecterSize = 1 << CH378ReadVar8( VAR8_DISK_SEC_LEN );	 /* ǰUÿС */  

		/* MY_ADC.TXTļѾݵβ,½ļ */
		printf( "Open\n" );
		status = CH378FileOpen( "/MY_ADC.TXT" );  				 /* ļ,ļڸĿ¼ */
		if( status == ERR_SUCCESS ) 
		{  
			/* ļڲѾ,ƶļָ뵽βԱ */
			printf( "File Size = %ld\n", CH378GetFileSize( ) );  /* ȡǰļ */
			printf( "Locate Tail\n" );
			status = CH378ByteLocate( 0xFFFFFFFF );  			 /* Ƶļβ */
			mStopIfError( status );
		}
		else if( status == ERR_MISS_FILE ) 
		{  
			/* ûҵļ,½ļ */
			printf( "Create\n" );
			status = CH378FileCreate( "/MY_ADC.TXT" );  		 /* ½ļ,ļѾɾ½ */
			mStopIfError( status );
		}
		else 
		{
			mStopIfError( status );  							 /* ļʱ */
		}

		printf( "Write Begin\n" );
		len = sprintf( buf, "ǰļ= %ld ֽ\xd\xa", CH378GetFileSize( ) );  /* עַȲbuf,Ӵ󻺳߷ֶд */
		status = CH378ByteWrite( buf, len, NULL );  			 /* ֽΪλļд */
		mStopIfError( status );

		printf( "Write ADC Data\n" );
		TR0 = 1;  												 /* öʱ0ļֵADC */
		for( hour = 8; hour != 20; hour++ ) 
		{  
			/* ѭʽ12 */
			month = 5;  										 /* ٶ5 */
			date = TL1 & 0x1F;  								 /* Ϊ԰ûʵʱʱоƬ,öʱ1ļʾ */
/*			adc = get_adc_data( ); */
			adc = ( (UINT16)TH0 << 8 ) | TL0;  				 	 /* Ϊ԰ûADC,öʱ0ļADCʾ */
			len = sprintf( buf, "%02d.%02d.%02d ADC=%u\xd\xa", (UINT16)month, (UINT16)date, (UINT16)hour, adc );  /* ݸʽΪһַ */
			status = CH378ByteWrite( buf, len, NULL );  		 /* ֽΪλļд */
			/* ЩUܻ̿Ҫдݺȴһܼ,,ĳЩUзݶʧ,
			   ÿдݺʱټ */
			mStopIfError( status );
			printf( "Current offset ( file point ) is %ld\n", CH378ReadVar32( VAR32_CURRENT_OFFSET ) );  /* ȡǰļָ */
		}
//		CH378ByteWrite( buf, 0, NULL );  						 /* ֽΪλļд,Ϊ0ֽд,ֻڸļĳ,׶дݺ,ְ취ļ */

		printf( "Write End\n" );
		strcpy( buf, "ADCݵ˽\xd\xa" );
		status = CH378ByteWrite( buf, strlen( buf ), NULL );  	 /* ֽΪλļд */
		mStopIfError( status );
		
		/* ʵʲƷʵʱʱ,ԸҪļںʱ޸Ϊʵֵ,οEXAM10ʵ */
		printf( "Close\n" );
		status = CH378FileClose( TRUE );  						 /* رļ,Զļ,ֽΪλдļ,óرļԱԶļ */
		mStopIfError( status );
	
UnknownUsbDevice:
		printf( "Take out\n" );
		while( CH378DiskConnect( ) == ERR_SUCCESS ) 
		{  
			/* UǷ,ȴṴγ */
			mDelaymS( 100 );
		}
		mDelaymS( 200 );
	}
}


