/********************************** (C) COPYRIGHT *******************************
* File Name          : PARA_HW.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378оƬ Ӳ׼8λӵӲ V1.2
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "HAL.H"

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/*  Ƭ       CH378оƬ
        P2.0                 A0
        P2.6                 CS#      ֻCH378,ôCS#ֱӽӵ͵ƽ,ǿƬѡ */
        
UINT8V  xdata	  CH378_CMD_PORT   _at_ 0xBDF1;				 	 /* ٶCH378˿ڵI/Oַ */
UINT8V  xdata	  CH378_DAT_PORT   _at_ 0xBCF0;				 	 /* ٶCH378ݶ˿ڵI/Oַ */

#define CH378_INT_WIRE			   INT0						 	 /* ٶCH378INT#,δôҲͨѯ״̬˿ʵ */

/*******************************************************************************
* Function Name  : CH378_Port_Init
* Description    : CH378˿ڳʼ
*                  ʹñ׼ڶдʱ,ʼ 
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void )
{
}

/*******************************************************************************
* Function Name  : mDelay0_5uS
* Description    : ʱ0.5΢
*                  ʱ0.5uS,ݵƬƵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mDelay0_5uS( void )
{
}

#define	xReadCH378Status( )		   ( CH378_CMD_PORT )  			 /* CH378״̬,ڲڷʽ */
#define	xEndCH378Cmd( )  										 /* CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd )  							
{		
	CH378_CMD_PORT = mCmd;
	
#if 1		
	mDelay0_5uS( ); 
	mDelay0_5uS( ); 							
#endif

#if 0
	/* ʱ1uSȷдڴ1uS,漸е״̬ѯ */
	for( i = 10; i != 0; -- i ) 
	{  
		/* ״̬ѯ,ȴCH378æ,һеʱ1uS */
		if( ( xReadCH378Status( ) & PARA_STATE_BUSY ) == 0 ) 
		{
			break;  											 /* ״̬˿ڵæ־λ */
		}
	}
#endif
}

#ifdef FOR_LOW_SPEED_MCU  										 /* Ҫʱ */

#define	xWriteCH378Data( d )	   { CH378_DAT_PORT = d; }  	 /* CH378д */
#define	xReadCH378Data( )		   ( CH378_DAT_PORT )  			 /* CH378 */

#else

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---ҪдCH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData )  		
{
	CH378_DAT_PORT = mData;
//	mDelay0_5uS( );  											 /* ȷдڴ0.6uS */
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void )  
{
//	mDelay0_5uS( );  											 /* ȷдڴ0.3uS */
	return( CH378_DAT_PORT );
}
#endif

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯ״̬˿ */
#ifdef	CH378_INT_WIRE

	if( CH378_INT_WIRE == 0x00 )
	{
		mDelayuS( 10 );
		if( CH378_INT_WIRE == 0x00 )
		{
			return( TRUE );
		}		
	}
	return( FALSE );  
//	return( CH378_INT_PIN_WIRE( ) ? FALSE : TRUE );  
#else
	return( xReadCH378Status( ) & PARA_STATE_INTB ? FALSE : TRUE );  
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void ) 
{
	UINT8 i, res;

	/* CH378Ƿ */
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );  											 /* ڷʽҪ */
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
//	xWriteCH378Data( 0x03 );									 /* SD */
	xWriteCH378Data( 0x06 );									 /* USB洢豸 */

	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	/* ڲģʽԶζȡж */
	for( i = 0; i < 10; i++ )
	{
		mDelaymS( 10 );											 
		res = xReadCH378Data( );
		if( res == CMD_RET_SUCCESS ) 
		{
			xEndCH378Cmd( );  									 /* ڷʽҪ */
			return( ERR_SUCCESS );
		}
	}
	xEndCH378Cmd( );  											 /* ڷʽҪ */
	return( ERR_USB_UNKNOWN );  						  	     /* ģʽ */
}
