/********************************** (C) COPYRIGHT *******************************
* File Name          : PARA_SW.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378оƬ ģ8λӵӲ V1.0
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "HAL.H"

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/*   Ƭ                  CH378оƬ
	 D0---D7(PB8---PB15) 	          D0---D7
		PB7								PCS#
		PB6								A0				 	
		PB5								WR#
		PB4								RD#
		PA1							    INT#	
*/

#define PIN_CH378_PCS_LOW( )       ( GPIOB->BRR  = GPIO_Pin_7 )  /* ģⲢƬѡ͵ƽ */
#define PIN_CH378_PCS_HIGH( )      ( GPIOB->BSRR = GPIO_Pin_7 )  /* ģⲢƬѡߵƽ */
#define PIN_CH378_A0_LOW( )        ( GPIOB->BRR  = GPIO_Pin_6 )  /* ģⲢA0͵ƽ */
#define PIN_CH378_A0_HIGH( )       ( GPIOB->BSRR = GPIO_Pin_6 )  /* ģⲢA0ߵƽ */
#define PIN_CH378_WR_LOW( )        ( GPIOB->BRR  = GPIO_Pin_5 )  /* ģⲢWR͵ƽ */
#define PIN_CH378_WR_HIGH( )       ( GPIOB->BSRR = GPIO_Pin_5 )  /* ģⲢWRߵƽ */
#define PIN_CH378_RD_LOW( )        ( GPIOB->BRR  = GPIO_Pin_4 )  /* ģⲢRD͵ƽ */
#define PIN_CH378_RD_HIGH( )       ( GPIOB->BSRR = GPIO_Pin_4 )  /* ģⲢRDߵƽ */

#define CH378_DATA_SET_IN( )	   { GPIOB->CRH = 0x44444444; }  /* CH378Ϊģʽ */    
#define CH378_DATA_SET_OUT( )	   { GPIOB->CRH = 0x33333333; }  /* CH378Ϊģʽ */

#define CH378_INT_WIRE             1	 
#define	CH378_INT_PIN_WIRE( )	   GPIO_ReadInputDataBit( GPIOA, GPIO_Pin_1 ) /* ٶCH378INT#,δôҲͨѯжSDO״̬ʵ */

/*******************************************************************************
* Function Name  : CH378_Port_Init
* Description    : CH378˿ڳʼ
*                  ʹͨI/OģⲢڶдʱ,Խгʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void ) 
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* еPB3PB4Ӧ뵥ƬJTAG,ԱȽJTAG */
	GPIO_PinRemapConfig( GPIO_Remap_SWJ_Disable, ENABLE ); 
	
	/* CH378ӦPCS#(PB7)A0(PB6)WD#(PB5)RD#(PB4)Ϊ */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_6 | GPIO_Pin_5 | GPIO_Pin_4;			
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;			 /* ʽ */
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;            /* ٶ50MHZ */
	GPIO_Init( GPIOB, &GPIO_InitStructure );

	/* CH378ӦPCS#(PB7)A0(PB6)WD#(PB5)RD#(PB4)Ĭߵƽ */
	PIN_CH378_PCS_HIGH( );
	PIN_CH378_A0_LOW( );
	PIN_CH378_WR_HIGH( );
	PIN_CH378_RD_HIGH( );
	
	/* CH378ӦPB8---PB15Ϊ */
  	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11
  	                            | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;			
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;			 /* ʽ */
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;            /* ٶ50MHZ */
	GPIO_Init( GPIOB, &GPIO_InitStructure );

	/* CH378ӦINT#(PA1)Ϊ */		
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;  				 /*  */
    GPIO_Init( GPIOA, &GPIO_InitStructure );					   
}

/*******************************************************************************
* Function Name  : xReadCH378Status
* Description    : CH378״̬,ڲڷʽ
* Input          : None
* Output         : None
* Return         : ضȡ״̬
*******************************************************************************/
UINT8 xReadCH378Status( void )  
{
	UINT8  mData;

	PIN_CH378_A0_HIGH( );
	PIN_CH378_PCS_LOW( );
	PIN_CH378_RD_LOW( );										 /* Чź, CH378оƬ״̬˿ */		
	/* ò,ʱ,CH378Ҫдȴ40nS,ǿҽ˴ִһָʱȷ㹻ʱ */
	PIN_CH378_PCS_LOW( );											 
	mData = (UINT8)( ( GPIOB->IDR ) >> 8 );						 /* CH378Ĳ */
	PIN_CH378_RD_HIGH( );										 /* ЧĿź, ɲCH378оƬ */
	PIN_CH378_PCS_HIGH( );
	PIN_CH378_A0_HIGH( );
	return( mData );
}

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---Ҫд뵽CH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd ) 
{
	GPIOB->ODR = ( GPIOB->ODR & 0x00FF ) | ( mCmd << 8 );		 /* CH378Ĳ */	
	CH378_DATA_SET_OUT( );										 /* òڷΪ */
	PIN_CH378_A0_HIGH( );	
	PIN_CH378_PCS_LOW( );	
	PIN_CH378_WR_LOW( );										 /* Чдź, дCH378оƬ˿ */		
	PIN_CH378_PCS_LOW( );								 		 /* ò,ʱ,CH378Ҫдȴ40nS */
	PIN_CH378_WR_HIGH( );										 /* ЧĿź, ɲCH378оƬ */
	PIN_CH378_PCS_HIGH( );	
	PIN_CH378_A0_LOW( );	
	CH378_DATA_SET_IN( );										 /* ֹ */
	mDelayuS( 2 );  	
}

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---Ҫд뵽CH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData )  
{
	GPIOB->ODR = ( GPIOB->ODR & 0x00FF ) | ( mData << 8 );		 /* CH378Ĳ */	
	CH378_DATA_SET_OUT( );										 /* òڷΪ */ 
	PIN_CH378_PCS_LOW( );
	PIN_CH378_WR_LOW( );										 /* Чдź, дCH378оƬݶ˿ */		
	PIN_CH378_PCS_LOW( );									 	 /* ò,ʱ,CH378Ҫдȴ40nS */
	PIN_CH378_WR_HIGH( );										 /* ЧĿź, ɲCH378оƬ */
	PIN_CH378_PCS_HIGH( );
	CH378_DATA_SET_IN( );										 /* ֹ */							
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void )  
{
	UINT8  mData;

	PIN_CH378_PCS_LOW( );
	PIN_CH378_RD_LOW( );										 /* Чź, CH378оƬݶ˿ */
	/* ò,ʱ,CH378Ҫдȴ40nS,ǿҽ˴ִһָʱȷ㹻ʱ */
	PIN_CH378_PCS_LOW( );
	mData = (UINT8)( ( GPIOB->IDR ) >> 8 );						 /* CH378Ĳ */
	PIN_CH378_RD_HIGH( ); 										 /* ЧĿź, ɲCH378оƬ */
	PIN_CH378_PCS_HIGH( );
	PIN_CH378_PCS_HIGH( );
	return( mData );
}

#define	xEndCH378Cmd( )  										 /* CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯ״̬˿ */	
#ifdef	CH378_INT_WIRE

	if( CH378_INT_PIN_WIRE( ) == 0x00 )
	{
		mDelayuS( 10 );
		if( CH378_INT_PIN_WIRE( ) == 0x00 )
		{
			return( TRUE );
		}		
	}
	return( FALSE );  
//	return( CH378_INT_PIN_WIRE( ) ? FALSE : TRUE );  
#else
	return( xReadCH378Status( ) & PARA_STATE_INTB ? FALSE : TRUE );  
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void )  
{
	UINT8 i, res;

	/* CH378Ƿ */
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );  											 /* ڷʽҪ */
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );									 /* SD */
	xWriteCH378Data( 0x07 );									 /* USB洢豸 */
	
	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	/* ڲģʽԶζȡж */
	for( i = 0; i < 10; i++ )
	{
		mDelaymS( 10 );											 
		res = xReadCH378Data( );
		if( res == CMD_RET_SUCCESS ) 
		{
			xEndCH378Cmd( );  									 /* ڷʽҪ */
			return( ERR_SUCCESS );
		}
	}
	xEndCH378Cmd( );  											 /* ڷʽҪ */
	return( ERR_USB_UNKNOWN );  						  	     /* ģʽ */
}
