// 2003.09.08, 2003.12.28
//****************************************
//**  Copyright  (C)  W.ch  1999-2005   **
//**  Web:  http://www.winchiphead.com  **
//****************************************
//**  DLL for USB interface chip CH375  **
//**  C, VC5.0                          **
//****************************************
//
// USB߽ӿоƬCH375ݿԳ V1.0
// Ͼߺ޹˾  : W.ch 2003.12
// CH375-BLK  V1.0
// л: Windows 98/ME, Windows 2000/XP
// support USB chip: CH372/CH375
//

// ݴȷ,ڳʱ,ӦĵƬ˵ĲԳΪTEST.C
// : ´ȵݰ,Ƭղݰλȡ󷵻,ɼպȽǷȷ


#include	<windows.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<conio.h>
#include	<winioctl.h>

#include	"CH375DLL.H"				// CH375Ķ̬ӿ

// ڼ͵ƬӦó֮Լ´ݵֽ
#define		TEST_DATA			0x21	// ȷ

#define		TEST_DATA_LEN		512
//
void main ( )
{
	int				key;
	unsigned char	mBuffer[TEST_DATA_LEN];
	unsigned char	mReadBuf[TEST_DATA_LEN];
	unsigned long	i, mLength, mTestCount, mErrCnt, mStep, mTotal,PipeIndex;

	printf( "\nCH372/CH375 Bulk Data Test Program V1.1 ,   Copyright (C) W.ch 2004.12\n" );
	printf( "test data correctness \n" );

// ҪʹDLLҪȼ,ûд˾Զ
	printf( "*** Load DLL: CH375DLL.DLL \n" );
	if ( LoadLibrary( "CH375DLL.DLL" ) == NULL ) return;  // DLLʧ,δװϵͳ

	printf( "*** CH375OpenDevice: 0# \n" );
	if ( CH375OpenDevice( 0 ) == INVALID_HANDLE_VALUE ) return;  /* ʹ֮ǰ豸 */

	CH375SetTimeout( 0, 5000, 5000 );  // USBݶдĳʱ,5000mSδɶдǿƷ,һֱȴȥ

	mErrCnt=0;

	printf( "*** Step-1: test data correctness: 10000000 times, random length and data\n" );
	for ( mTestCount=0; mTestCount<10000000; ++mTestCount )  // ѭ
	{
		mStep=mTestCount&0x03;
		switch( mStep )
		{
			case 0: memset( mBuffer, 0x00, TEST_DATA_LEN );  // ȫ00H/ȫFFH
					break;
			case 1: memset( mBuffer, 0xff, TEST_DATA_LEN );  // ȫFFH/ȫ00H
					break;
			default: for ( i=0; i<TEST_DATA_LEN; i++ ) mBuffer[i]=(unsigned char)( rand() );  // /λ
					break;
		}
		PipeIndex=rand();  // ˵ַ
		PipeIndex = (PipeIndex&0x00000001)+1; 

		mBuffer[0]=TEST_DATA;
		mTotal=rand();  // 
		mTotal=mTotal%TEST_DATA_LEN;
		if ( mTotal == 0 || mTotal > TEST_DATA_LEN ) mTotal=TEST_DATA_LEN;
		printf( "Cnt=%4ld, Len=%2ld, Data: %02XH,%02XH,%02XH,%02XH,%02XH,%02XH...\xd", mTestCount, mTotal, mBuffer[0], mBuffer[1], mBuffer[2], mBuffer[3], mBuffer[4], mBuffer[5] );
		if ( kbhit() )
		{
			key = getch( );
			if ( key == 0x1b || key == 0x20 ) {  // ESC߿ոֹѭ
				printf( "*** CH375CloseDevice by break: 0              \n" );
				CH375CloseDevice( 0 );
				exit(2);
				break;
			}
		}
		if ( CH375WriteEndP( 0, PipeIndex ,mBuffer, &mTotal ) )  // ͳɹ
		//if ( CH375WriteData( 0 ,mBuffer, &mTotal ) )  // ͳɹ
		{
			mLength = TEST_DATA_LEN;
			if ( mTestCount == 0 ) Sleep( 200 );  // ǵ֮ǰƬ׼ϴݿδȡ,״λشпֱӶ֮ǰݶǱݵȡ,״λشȵȴƬ׼ȡ
			if ( CH375ReadEndP( 0, PipeIndex, mReadBuf, &mLength ) )  // ճɹ
			//if ( CH375ReadData( 0, mReadBuf, &mLength ) )  // ճɹ
			{
				if ( mLength != mTotal || mLength==0 ) {  // ȴ
					mErrCnt++;
					printf( "S1-T%0ld-C%ld return length error: %ld (%ld)\n", mStep, mTestCount, mLength, mTotal );
				}
				else {
					for ( i=0; i<mLength; ++i ) {
						//if ( (mReadBuf[i]^0xff)!=mBuffer[i] ) {  // ȡֵȽϴ
						if ( (mReadBuf[i])!=mBuffer[i] ) {  // ȡֵȽϴ
							mErrCnt++;
							printf( "S1-T%0ld-C%ld return data error at %ld: %02XH (%02XH)\n", mStep, mTestCount, i, mReadBuf[i], mBuffer[i] );
						}
					}
				}
			}
			else {  // ʧ
				mErrCnt++;
				printf( "S1-T%0ld-C%ld CH375ReadData return error, length=%ld\n", mStep, mTestCount, mTotal );
			}
		}
		else {  // дʧ
			mErrCnt++;
			printf( "S1-T%0ld-C%ld CH375WriteData return error, length=%ld\n", mStep, mTestCount, mTotal );
		}
	}
	if ( mErrCnt==0 ) printf( "*** passed                                             \n" );
// رCH375豸,ʹر豸,дӲеļҪرһ
	printf( "*** Total error = %ld \n", mErrCnt );
	printf( "*** CH375CloseDevice: 0 \n" );
	CH375CloseDevice( 0 );

	printf( "\nExit.\n" );
	getch();
}
