/********************************** (C) COPYRIGHT *******************************
* File Name          : CH378INC.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/11/25
* Description        : C Define for CH378
*					   Website: http://wch.cn
*					   Email:   tech@wch.cn 		
*******************************************************************************/



#ifndef __CH378INC_H__
#define __CH378INC_H__

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************/
/* оƬ汾 */					
#define	DEF_CH378_VER		  	   0x42							 /* ǰоƬ̼汾,2λΪоƬ汾,6λΪ̼汾 */

/***********************************************************************************************************************/
/* ͺͳ */

#ifndef		TRUE
#define		TRUE	1
#define		FALSE	0
#endif
#ifndef		NULL
#define		NULL	0
#endif

#ifndef UINT8
typedef unsigned char              UINT8;
#endif
#ifndef UINT16
typedef unsigned short             UINT16;
#endif
#ifndef UINT32
typedef unsigned long              UINT32;
#endif
#ifndef PUINT8
typedef unsigned char              *PUINT8;
#endif
#ifndef PUINT16
typedef unsigned short             *PUINT16;
#endif
#ifndef PUINT32
typedef unsigned long              *PUINT32;
#endif
#ifndef UINT8V
typedef unsigned char volatile     UINT8V;
#endif
#ifndef PUINT8V
typedef unsigned char volatile     *PUINT8V;
#endif

/* ********************************************************************************************************************* */
/* ˵: 
   (1)CH376оƬ, ݻݵĿֲܾͬ;
   (2)һ˳:
          aһ(ڴڷʽ,֮ǰҪͬ);
          bɸ(0);
          cж֪ͨɸ(0), ѡһ, ж֪ͨһû, һж;
             CMD01_WR_REQ_DATA, ˳: һ, һ, ɸ   
   (3): CMDxy_NAME
        еxy, x˵ݸ(ֽ), y˵ݸ(ֽ), yH˵ж֪ͨ,
        Щܹʵ0ֽڵݿд, ݿ鱾ֽδxy֮ */

/* ********************************************************************************************************************* */
/* Ҫ(ֲһ), , ڲʱж֪ͨ */

#define	CMD01_GET_IC_VER		   0x01							 /* ȡоƬ̼汾 */
/* : 汾( λ7Ϊ0, λ6Ϊ1, λ5~λ0Ϊ汾 ) */
/*       CH378ذ汾ŵֵΪ040H汾Ϊ00H */

#define	CMD31_SET_BAUDRATE		   0x02							 /* ڷʽ: ôͨѶ(ϵ߸λĬϲΪ9600bps,SCK/SDI/SDOѡ) */
/* : 3ֽڲϵ,ֽǰ */
/* : ״̬( CMD_RET_SUCCESSCMD_RET_ABORT, ֵ˵δ ) */

#define	CMD10_ENTER_SLEEP		   0x03							 /* ˯״̬ */
/* : 1ֽڲ, Ϊ0x11,ʹоƬ˯״̬,֮USBܿԼʹ;
                      Ϊ0x22,ʹоƬ˯״̬,֮USB豸,Ҫȫ³ʼ; */

#define	CMD00_RESET_ALL			   0x05							 /* ִӲλ */

#define	CMD11_CHECK_EXIST	       0x06							 /* ͨѶӿں͹״̬ */
/* :  */
/* : ݵİλȡ */

#define	CMD20_SET_SDO_INT		   0x0B						 	 /* SPIӿڷʽ: SPISDOŵжϷʽ */
/* : 16H, жϷʽ */
/*           00H=ֹSDOж,SCSƬѡЧʱֹ̬, 01H=SDOSCSƬѡЧʱж */

#define	CMD14_GET_FILE_SIZE		   0x0C							 /* ļģʽ: ȡǰļ */
/* : 68H */
/* : ǰļ(ܳ32λ,ֽǰ) */

#define	CMD11_SET_USB_MODE		   0x15							 /* USBģʽ */
/* : ģʽ */
/*       00H=δõ豸ʽ, 01H=õ豸ʽʹⲿ̼ģʽ, 02H=õ豸ʽʹù̼ģʽ */
/*       03H=SDģʽ/δõģʽ,ڹʹȡSDеļ */
/*       04H=SDģʽ/õģʽ,ڹʹȡSDеļ */
/*       05H=δõʽ */
/*       06H=USBģʽ/δõģʽ,ڹʹȡUSB洢豸еļ */
/*       07H=USBģʽ/õģʽ,ڹʹȡUSB洢豸еļ */
/* : ״̬( CMD_RET_SUCCESSCMD_RET_ABORT, ֵ˵δ ) */

#define	CMD01_GET_STATUS		   0x22							 /* ȡж״̬ȡж */
/* : ж״̬ */

#define	CMD40_RD_HOST_OFS_DATA	   0x26							 /* ģʽ: ȡڲָָƫƵַݿ(ڲָԶ) */
/* : ƫƵַ( 2ֽ,ֽǰ,Ϊ20480 )ȡ(2ֽ,ֽǰ,Ϊ20480) */
/* :  */
/* ע: ,ֻǰʵʻ */

#define	CMD20_RD_HOST_CUR_DATA     0x27							 /* ģʽ: ȡڲָǰƫƵַݿ(ڲָԶ) */
/* : ȡ(2ֽ,ֽǰ,Ϊ20480) */
/* :  */
/* ע: ,ֻǰʵʻ */

#define	CMD00_RD_HOST_REQ_DATA	   0x28							 /* ģʽ: ȡڲָǰƫƵַȡݿ(ڲָԶ) */
/* : ȡ(2ֽ,ֽǰ,Ϊ20480) */
/* :  */
/* ע: ,ֻǰʵʻ */

#define	CMD40_WR_HOST_OFS_DATA	   0x2D							 /* ģʽ: ڲָָƫƵַдݿ(ڲָԶ) */
/* : ƫƵַ( 2ֽ,ֽǰ,Ϊ20480 )볤(2ֽ,ֽǰ,Ϊ20480) */
/* ע: ,дݻԶӻʼַʼ */

#define	CMD20_WR_HOST_CUR_DATA	   0x2E							 /* ģʽ: ڲָǰƫƵַдݿ(ڲָԶ) */
/* : 볤(2ֽ,ֽǰ,Ϊ20480) */
/* ע: ,дݻԶӻʼַʼ */

#define	CMD10_SET_FILE_NAME		   0x2F							 /* ļģʽ: ýҪļļ· */
/* : 0ַ(0ڳȲMAX_FILE_NAME_LENַ) */


/* ********************************************************************************************************************* */
/* Ҫ(ֲһ), , ڲʱж֪ͨ, û */

#define	CMD0H_DISK_CONNECT		   0x30							 /* ļģʽ: Ƿ */
/* ж */

#define	CMD0H_DISK_MOUNT		   0x31							 /* ļģʽ: ʼ̲ԴǷ */
/* ж */

#define	CMD0H_FILE_OPEN			   0x32							 /* ļģʽ: ļĿ¼(ļ),öļĿ¼(ļ) */
/* ж */

#define	CMD0H_FILE_ENUM_GO		   0x33							 /* ļģʽ: öļĿ¼(ļ) */
/* ж */

#define	CMD0H_FILE_CREATE		   0x34							 /* ļģʽ: ½ļ,ļѾôɾ */
/* ж */

#define	CMD0H_FILE_ERASE		   0x35							 /* ļģʽ: ɾļ,Ѿֱɾ,ļȴɾ,Ŀ¼ȴ */
/* ж */

#define	CMD1H_FILE_CLOSE		   0x36							 /* ļģʽ: رյǰѾ򿪵ļĿ¼(ļ) */
/* : Ƿļ */
/*       00H=ֹ³, 01H=³ */
/* ж */

#define	CMD1H_DIR_INFO_READ		   0x37							 /* ļģʽ: ȡļĿ¼Ϣ */
/* : ָҪȡĿ¼Ϣṹڵ */
/*       ŷΧΪ00H~0FH, 0FFHΪǰѾ򿪵ļ */
/* ж */

#define	CMD1H_DIR_INFO_SAVE		   0x38							 /* ļģʽ: ļĿ¼Ϣ */
/* : ָҪдĿ¼Ϣṹڵ */
/*       ŷΧΪ00H~0FH, 0FFHΪǰѾ򿪵ļ */
/* ж */

#define	CMD4H_BYTE_LOCATE	       0x39							 /* ļģʽ: ֽΪλƶǰļָ */
/* : ƫֽ(ܳ32λ,ֽǰ) */
/* ж */

#define	CMD2H_BYTE_READ			   0x3A						 	 /* ļģʽ: ֽΪλӵǰλöȡݿ */
/* : ȡֽ(ܳ16λ,ֽǰ,Ϊ20480) */
/* ж */
/* ע: ͸ȡʵڲ,ҪͨCMD40_RD_HOST_OFS_DATACMD20_RD_HOST_CUR_DATAȡ */

#define	CMD2H_BYTE_WRITE		   0x3C							 /* ļģʽ: ֽΪλǰλдݿ */
/* : дֽ(ܳ16λ,ֽǰ,Ϊ20480) */
/* ж */
/* ע: øǰҪͨCMD40_WR_HOST_OFS_DATACMD20_WR_HOST_CUR_DATAҪдԤ䵽ڲ */

#define	CMD0H_DISK_CAPACITY		   0x3E							 /* ļģʽ: ѯ */
/* ж */

#define	CMD0H_DISK_QUERY		   0x3F							 /* ļģʽ: ѯ̿ռϢ */
/* ж */

#define	CMD0H_DIR_CREATE		   0x40							 /* ļģʽ: ½Ŀ¼(ļ),Ŀ¼ѾôֱӴ */
/* ж */

#define	CMD4H_SEC_LOCATE		   0x4A						   	 /* ļģʽ: Ϊλƶǰļָ */
/* : ƫ(ܳ32λ,ֽǰ) */
/* ж */

#define	CMD1H_SEC_READ			   0x4B							 /* ļģʽ: Ϊλӵǰλöȡݿ */
/* : ȡ */
/* ж */
/* ע: ڲС,дΪ40 */

#define	CMD1H_SEC_WRITE			   0x4C							 /* ļģʽ: Ϊλڵǰλдݿ */
/* : д */
/* ж */
/* ע: ڲС,дΪ40 */

#define	CMD0H_DISK_BOC_CMD		   0x50							 /* ʽ/֧SD: USB洢ִBulkOnlyЭ */
/* ж */

#define	CMD5H_DISK_READ			   0x54							 /* ʽ: USB洢SD */
/* : LBAַ(ܳ32λ, ֽǰ), (01H~28H) */
/* ж */
/* ע: ڲС,дΪ40 */

#define	CMD5H_DISK_WRITE		   0x56							 /* ʽ: USB洢SDд */
/* : LBAַ(ܳ32λ, ֽǰ), (01H~FFH) */
/* ж */
/* ע: ڲС,дΪ40 */
/* ע: øǰҪͨCMD40_WR_HOST_OFS_DATACMD20_WR_HOST_CUR_DATAҪдԤ䵽ڲ */

#define	CMD0H_FILE_QUERY		   0x55							 /* ļģʽ: ѯǰļϢ */
/* ж */
/* ע: ݸʽ: 4ֽļȡ2ֽļڡ2ֽļʱ䡢1ֽļ */

#define	CMD0H_FILE_MODIFY		   0x57							 /* ļģʽ: ѯ޸ĵǰļϢ */
/* ж */
/* ע: ݸʽ: 4ֽļȡ2ֽļڡ2ֽļʱ䡢1ֽļ */


/* ********************************************************************************************************************* */
/* Ҫ(ֲ), ǳ, ڲʱж֪ͨ */

#define	CMD20_BULK_WR_TEST		   0x07							 /* дݲ */
/* : 2ֽںݳ,Nֽں */

#define	CMD20_BULK_RD_TEST		   0x08							 /* ݲ */
/* : 2ֽںݳ */
/* : Nֽں */

#define	CMD11_READ_VAR8			   0x0A							 /* ȡָ8λCH378ϵͳ */
/* : ַ */
/* : ǰַӦ8λ */

#define	CMD11_GET_DEV_RATE		   0x0A							 /* ʽ: ȡǰӵUSB豸 */
/* : 07H */
/* :  */
/*           00ʾٶδ֪; 01ʾ1.5MbpsUSB豸; 02ʾ12MbpsȫUSB豸; 03ʾ480MbpsUSB豸 */

#define	CMD20_WRITE_VAR8		   0x0B							 /* ָ8λCH378ϵͳ */
/* : ַ,  */

#define	CMD14_READ_VAR32		   0x0C							 /* ȡָ32λCH378ϵͳ */
/* : ַ */
/* : ǰַӦ32λ(ܳ32λ,ֽǰ) */

#define	CMD50_WRITE_VAR32		   0x0D							 /* ָ32λCH378ϵͳ */
/* : ַ, (ܳ32λ,ֽǰ) */

#define	CMD50_SET_FILE_SIZE		   0x0D							 /* ļģʽ: õǰļ */
/* : 68H, ǰļ(ܳ32λ,ֽǰ) */
/* ע⣺ֻʱı䵱ǰ򿪵ļļ */

#define	CMD02_GET_REAL_LEN		   0x0E							 /* ٷһִϺ󳤶Ӧʵʳ */
/* : 4ֽʵ, ֽǰ */
/* ע: ʹֽڶλֽڶдλдʱʹ,Լӿִٶ  */

#define	CMD01_TEST_CONNECT		   0x16							 /* ʽ: USB豸/SD״̬ */
/* : ״̬( USB_INT_CONNECTUSB_INT_DISCONNECTUSB_INT_USB_READY, ֵ˵δ ) */

#define	CMD00_DIRTY_BUFFER		   0x25							 /* ļģʽ: ڲĴ̺ļ */

/* ********************************************************************************************************************* */
/* Ҫ(ֲ), ǳ, ڲʱж֪ͨ, û */

#define	CMD1H_CLR_STALL			   0x41							 /* ʽ/֧SD: ƴ-˵ */
/* : ˵ */
/* ж */

#define	CMD1H_SET_ADDRESS		   0x45							 /* ʽ/֧SD: ƴ-USBַ */
/* : ֵַ */
/* ж */

#define	CMD1H_GET_DESCR			   0x46							 /* ʽ/֧SD: ƴ-ȡ */
/* :  */
/* ж */

#define	CMD1H_SET_CONFIG		   0x49							 /* ʽ/֧SD: ƴ-USB */
/* : ֵ */
/* ж */

#define	CMD0H_AUTO_SETUP		   0x4D							 /* ʽ/֧SD: ԶUSB豸 */
/* ж */

#define	CMD0H_ISSUE_CTRL_TRAN	   0x4E							 /* ʽ/֧SD: ִпƴ */
/* ж */
/* ע: ǰ,ͨCMD40_WR_HOST_OFS_DATA8ֽڵSETUPд뵽ڲ,ҪͨOUT׶´ݰ,
         Ҫݰ8ֽڵSETUPд뵽ڲ */

#define	CMD0H_DISK_INIT			   0x51							 /* ʽ/֧SD: ʼUSB洢 */
/* ж */

#define	CMD0H_DISK_RESET		   0x52							 /* ʽ/֧SD: ƴ-λUSB洢 */
/* ж */

#define	CMD0H_DISK_SIZE			   0x53							 /* ʽ/֧SD: ȡUSB洢 */
/* ж */

#define	CMD0H_DISK_INQUIRY		   0x58						 	 /* ʽ/֧SD: ѯUSB洢 */
/* ж */

#define	CMD0H_DISK_READY		   0x59							 /* ʽ/֧SD: USB洢 */
/* ж */

#define	CMD0H_DISK_R_SENSE		   0x5A							 /* ʽ/֧SD: USB洢 */
/* ж */

#define	CMD0H_DISK_MAX_LUN		   0x5D							 /* ʽ/֧SD: ƴ-ȡUSB洢߼Ԫ */
/* ж */

#define	CMD10_SET_LONG_FILE_NAME   0x60							 /* ļģʽ: ýҪĳļļ(ļ) */
/* 볤(2ֽ,ֽǰ,Ϊ520)0ַ(ļȲ520ֽ) */

#define	CMD10_GET_LONG_FILE_NAME   0x61							 /* ļģʽ: ļ·(ļļ)õӦĳļ */
/* ж */
/* : ȡ(2ֽ,ֽǰ,Ϊ520)ļ */
/* ע⣺ǰ,ͨCMD10_SET_FILE_NAMEļ·CH378 */

#define	CMD0H_LONG_FILE_CREATE	   0x62							 /* ļģʽ: ½ļļ,ļѾôɾ */
/* ж */
/* ע⣺ǰ,ͨCMD10_SET_LONG_FILE_NAMECMD10_SET_FILE_NAMEֱ𽫳ļ,Լļ·CH378 */

#define	CMD0H_LONG_DIR_CREATE	   0x63							 /* ļģʽ: ½ļĿ¼(ļ),Ŀ¼ѾôֱӴ */
/* ж */
/* ע⣺ǰ,ͨCMD10_SET_LONG_FILE_NAMECMD10_SET_FILE_NAMEֱ𽫳ļ,Լļ·CH378 */

#define	CMD0H_AUTO_DEMO			   0x64							 /* оƬԶʾ,U̻SDԶΪоƬʾ.TXTļд뵱ǰϢ */
/* ж */

#define	CMD1H_GET_SHORT_FILE_NAME  0x65							 /* ļģʽ: ɲֶļ·ĳļõӦĶļ */
/* ж */
/* : ȡ(2ֽ,ֽǰ,ΪMAX_PATH_LEN)ļ· */
/* ע⣺ǰ,ͨCMD10_SET_FILE_NAMEֶļ·CH378,ͨCMD10_SET_LONG_FILE_NAME
   ĳļCH378 */

#define	CMD0H_LONG_FILE_OPEN	   0x66							 /* ļģʽ: ͨļļĿ¼(ļ) */
/* ж */

#define	CMD0H_LONG_FILE_ERASE	   0x67							 /* ļģʽ: ͨļɾļ,Ѿֱɾ,ļȴɾ,Ŀ¼ȴ */
/* ж */
/* ********************************************************************************************************************* */
/* USB豸ģʽ */

#define	CMD40_SET_USB_ID		   0x11							 /* USBVIDͲƷPID */
/* : 4ֽVID\PID,ֱΪIDֽ, IDֽ, ƷIDֽ, ƷIDֽ */
/* עCMD11_SET_USB_MODEǰ */

#define	CMD10_SET_USB_SPEED		   0x13							 /* USBٶ */
/* : 1ֽUSBٶֵ,0x00Ϊȫ,0x02Ϊ,ֵЧ */
/* עCMD11_SET_USB_MODEǰ */

#define	CMD01_GET_USB_SPEED		   0x14							 /* ȡUSBٶ */
/* : 1ֽڵUSBٶֵ, 0x00Ϊȫ,0x02Ϊ,ֵЧ */

#define	CMD70_INIT_ENDPx		   0x17							 /* USB˵(˵xΧ: 1--4) */
/* : 1ֽUSB˵: 1--4, 1ֽڶ˵, 1ֽڶ˵, 1ֽڶ˵㷽, 2ֽС(ֽǰ),1ֽڵж״̬  */
/* עCMD11_SET_USB_MODEǰ */

#define	CMD20_SET_INDEXx_IN		   0x18							 /* USB IN˵x(xΧ: 0--4)Ľ */
/* : 1ֽ, 1ֽڹʽ */
/*           λ7Ϊ1λö˵ͬλ
             λ6Ϊ1øö˵ӦʽΪSTALL
			 λ5Ϊ1ö˵֮ǰSTALLԣ
			 ʵϴ,оƬԶӦNAK */

#define	CMD20_SET_INDEXx_OUT	   0x19						 	 /* USB OUT˵x(xΧ: 0--4)ķ */
/* : 1ֽ, 1ֽڹʽ */
/*           λ7Ϊ1λö˵ͬλ
             λ6Ϊ1øö˵ӦʽΪSTALL
			 λ5Ϊ1ö˵֮ǰSTALLԣ
			 յ´ݰ,оƬԶӦACK */

#define	CMD10_UNLOCK_USB		   0x23							 /* ͷŵǰUSB */
/* : 1ֽUSB˵: 0--4 */

#define	CMD1x_RD_USB_DATA		   0x29							 /* ָUSBжϵĶ˵㻺ȡݿ,ͷŻ */
/* : 1ֽUSB˵: 0--4 */
/* : 2ֽڵݳ,  */

#define	CMD30_WR_USB_DATA	       0x2A							 /* ֮USB˵ķͻдݿ */
/* : 1ֽUSB˵: 1--4; 2ֽڵݳ; Nֽڵ */

#define	CMD10_WR_USB_DATA0	       0x2B							 /* USBƶ˵ķͻдݿ */
/* : 1ֽڵݳ; Nֽڵ */


/* ********************************************************************************************************************* */
/* USB豸ģʽٶȶ */
#define USB_DEV_SPEED_FS		   0x00							 /* ǰΪȫ豸 */
#define USB_DEV_SPEED_HS		   0x02							 /* ǰΪ豸 */

/* ˵ */
#define ENDP_INDEX_0       		   0x00							 /* ˵0ƶ˵ */ 	
#define ENDP_INDEX_1       		   0x01							 /* ˵1Զ˵ */
#define ENDP_INDEX_2       		   0x02							 /* ˵2Զ˵ */
#define ENDP_INDEX_3       		   0x03							 /* ˵3Զ˵ */
#define ENDP_INDEX_4       		   0x04							 /* ˵4Զ˵ */	

/* ˵㴫䷽ */
#define ENDP_DIR_IN		    	   0x00							 /* ϴ˵ */
#define ENDP_DIR_OUT			   0x01							 /* ´˵ */

/* ˵ */
#define ENDP_TYPE_RESERVED		   0x00							 /*  */
#define ENDP_TYPE_ISO			   0x01					 		 /* ͬ */
#define ENDP_TYPE_BULK			   0x02							 /*  */
#define ENDP_TYPE_INTERRUPT		   0x03							 /* жϴ */


/* ********************************************************************************************************************* */
/* оƬ˯ģʽ */
#ifndef	HALF_SLEEP_MODE
#define	HALF_SLEEP_MODE	   		   0x11							 /* ˯״̬,֮USBܿԼʹ  */
#define	FULL_SLEEP_MODE			   0x22							 /* ˯״̬,֮USB豸,Ҫȫ³ʼ */
#endif


/* ********************************************************************************************************************* */
/* ڷʽ, ״̬˿(˿)λ */
#ifndef	PARA_STATE_INTB
#define	PARA_STATE_INTB			   0x80							 /* ڷʽ״̬˿ڵλ7: жϱ־,Ч */
#define	PARA_STATE_BUSY			   0x10							 /* ڷʽ״̬˿ڵλ4: æ־,Ч */
#endif


/* ********************************************************************************************************************* */
/* ڷʽ, ǰͬ */
#ifndef	SER_CMD_TIMEOUT
#define	SER_CMD_TIMEOUT		       32						     /* ʱʱ, λΪmS, ֮ͬ估֮ͬļӦþ, ʱĴʽΪ */
#define	SER_SYNC_CODE1			   0x57							 /* ĵ1ͬ */
#define	SER_SYNC_CODE2			   0xAB				 	 	     /* ĵ2ͬ */
#define	SER_TIMEOUT_RET			   0x03FFFA				 	 	 /* ڽճʱ */
#endif


/* ********************************************************************************************************************* */
/* ״̬ */
#ifndef	CMD_RET_SUCCESS
#define	CMD_RET_SUCCESS			   0x51						  	 /* ɹ */
#define	CMD_RET_ABORT			   0x5F						     /* ʧ */
#define	CMD_PARAME_ERR			   0x5E						     /*  */
#define	CMD_IDENTIFY_ERR		   0x5D						     /* ޸ */
#define	CMD_TIMEOUT_ERR		   	   0x5C						     /* ʱ */
#endif


/* ********************************************************************************************************************* */
/* CH378ж״̬ */
#ifndef	USB_INT_WAKE_UP
#define	USB_INT_WAKE_UP		       0xE0						  	 /* CH378ж״̬ */
#endif


/* ********************************************************************************************************************* */
/* USBж״̬ */

/* ״̬0XHUSB豸ʽ */
/*   ù̼ģʽֻҪ: USB_INT_INDEX1_IN, USB_INT_INDEX2_OUT, USB_INT_INDEX3_IN, USB_INT_INDEX4_OUT */
/*   λ7-λ5Ϊ000 */
/*   λ4-λ3ָʾǰ, 00=OUT, 10=IN, 11=SETUP */
/*   λ2-λ0ָʾǰ˵, 000=0Ŷ˵, 001=1Ŷ˵, 010=2Ŷ˵,011=3Ŷ˵,100=4Ŷ˵, 101=USB, 110=USB߸λ */
/*   ˵Ϊ0ʱΪ˵0(ƶ˵), ˵Ϊ1-4ʱΪ˵, ˵š˵͡˵С˵㷽ڶ˵ʱ */

#define	USB_INT_EP0_SETUP	       0x18							 /* USB˵0SETUP */
#define	USB_INT_EP0_OUT		       0x00							 /* USB˵0OUT */
#define	USB_INT_EP0_IN		       0x10							 /* USB˵0IN */
#define	USB_INT_INDEX1_OUT	       0x01							 /* USB 1Ŷ˵OUT */
#define	USB_INT_INDEX1_IN	       0x11							 /* USB 1Ŷ˵IN */
#define	USB_INT_INDEX2_OUT	       0x02							 /* USB 2Ŷ˵OUT */
#define	USB_INT_INDEX2_IN	       0x12							 /* USB 2Ŷ˵IN */
#define	USB_INT_INDEX3_OUT	       0x03							 /* USB 3Ŷ˵OUT */
#define	USB_INT_INDEX3_IN	       0x13							 /* USB 3Ŷ˵IN */
#define	USB_INT_INDEX4_OUT	       0x04							 /* USB 4Ŷ˵OUT */
#define	USB_INT_INDEX4_IN	       0x14							 /* USB 4Ŷ˵IN */
#define	USB_INT_BUS_SUSP	       0x05							 /* USB߹ */
#define	USB_INT_BUS_RESET	       0x06							 /* USB߸λ */
#define	USB_INT_SET_CONFIG	       0x07							 /* USBյSET_CONFIG */


/* ״̬1XHUSBʽĲ״̬ */
#ifndef	USB_INT_SUCCESS
#define	USB_INT_SUCCESS			   0x14							 /* USBߴɹ */
#define	USB_INT_CONNECT			   0x15							 /* ⵽USB豸¼, ӻ߶Ͽ */
#define	USB_INT_DISCONNECT		   0x16						 	 /* ⵽USB豸Ͽ¼ */
#define	USB_INT_BUF_OVER		   0x17						 	 /* USB̫໺ */
#define	USB_INT_USB_READY		   0x18							 /* USB豸Ѿʼ(ѾUSBַ) */
#define	USB_INT_DISK_READ		   0x1D							 /* USB洢ݶ */
#define	USB_INT_DISK_WRITE		   0x1E							 /* USB洢д */
#define	USB_INT_DISK_ERR		   0x1F							 /* USB洢ʧ */
#endif


/* ״̬ļģʽµļϵͳ */
#ifndef ERR_SUCCESS
#define ERR_SUCCESS				   0x00			 				 /* ɹ */
#endif
#define	ERR_PARAMETER_ERROR		   0x03							 /* , Χ */
#ifndef	ERR_DISK_DISCON
#define	ERR_DISK_DISCON			   0x82							 /* δ,ܴѾϿ */
#define	ERR_LARGE_SECTOR	       0x84							 /* ̵̫,ֻ֧ÿ512ֽ */
#define	ERR_TYPE_ERROR		       0x92							 /* ̷Ͳ֧,ֻ֧FAT12/FAT16/BigDOS/FAT32,Ҫɴ̹· */
#define	ERR_BPB_ERROR			   0xA1						 	 /* δʽ,߲,ҪWINDOWSĬϲ¸ʽ */
#define	ERR_DISK_FULL			   0xB1							 /* ļ̫,ʣռ̫ٻѾû,Ҫ */
#define	ERR_FDT_OVER			   0xB2							 /* Ŀ¼(ļ)ļ̫,ûпеĿ¼,FAT12/FAT16Ŀ¼µļӦ512,Ҫ */
#define	ERR_FILE_CLOSE			   0xB4							 /* ļѾر,Ҫʹ,Ӧ´ļ */
#define	ERR_OPEN_DIR			   0x41							 /* ָ·Ŀ¼(ļ) */
#define	ERR_MISS_FILE			   0x42							 /* ָ·ļûҵ,ļƴ */
#define	ERR_FOUND_NAME			   0x43							 /* ƥļ,ҪĿ¼(ļ)ʵʽȴļ */

/* ³ļļϵͳӳ */
#define ERR_NO_NAME                0X44        					 /* ˶ļûгļĳļ */
#define ERR_BUF_OVER               0X45        					 /* ļ */
#define ERR_LONG_NAME              0X46        					 /* ĳļ */

/* ļϵͳļϵͳӳ */
#define	ERR_MISS_DIR			   0xB3							 /* ָ·ĳĿ¼(ļ)ûҵ,Ŀ¼ƴ */
#define	ERR_LONG_BUF_OVER		   0x48							 /* ļ */
#define	ERR_LONG_NAME_ERR		   0x49							 /* ļûжӦĳļ߳ļ */
#define	ERR_NAME_EXIST			   0x4A						 	 /* ͬĶļѾ,һļ */
#endif

/* ********************************************************************************************************************* */
/* ΪSDͲش */
#define SD_ERR_NO_CARD		 	   0x60					 		 /* ûȫ뵽 */
#define SD_ERR_USER_PARAM      	   0x61					 		 /* ûʹAPIʱڲд */
#define SD_ERR_CARD_PARAM		   0x62					 		 /* вд뱾ģ鲻ݣ */
#define	SD_ERR_VOL_NOTSUSP         0x63					 		 /* ֧3.3V */
#define SD_ERR_OVER_CARDRANGE	   0x64					 		 /* Χ */
#define SD_ERR_UNKNOWN_CARD        0x65					 		 /* ޷ʶ */
#define SD_ERR_WP_PROTECT          0x66            		 		 /* д */
#define SD_CARD_BUSY               0x67            		 		 /* ڶȡOCRĴʱ⵽BIT31Ϊ0ʾæ */
#define SD_BLOCK_ERROR             0x68            		 		 /* СһҪڵ512,޷ */

/* SDܷصĴ */
#define SD_ERR_CMD_RESPTYPE	 	   0x69					 		 /* ʹ */
#define SD_ERR_CMD_TIMEOUT     	   0x6A					 		 /* Ӧʱ */
#define SD_ERR_CMD_RESP		 	   0x6B					 		 /* Ӧ */
#define SD_Power_Up_Busy           0x6C					 		 /* ϵæ */

/*  */
#define SD_ERR_DATA_CRC16      	   0x6D							 /* CRC16У鲻ͨ */
#define SD_ERR_DATA_START_TOK	   0x6E					 		 /* ʱ,ݿʼƲȷ */
#define	SD_ERR_DATA_RESP		   0x6F					 		 /* дʱ,ӦƲȷ */

/* ȴ */
#define SD_ERR_TIMEOUT_WAIT    	   0x70					 		 /* дʱ,ʱ */
#define SD_ERR_TIMEOUT_READ    	   0x71					 		 /* ʱ */
#define	SD_ERR_TIMEOUT_WRITE	   0x72					 		 /* дʱ */
#define SD_ERR_TIMEOUT_ERASE   	   0x73					 		 /* ʱ */
#define	SD_ERR_TIMEOUT_WAITIDLE    0x74					 		 /* ʼʱ,ȴ˳״̬ʱ */

/* дܷصĴ */
#define	SD_ERR_WRITE_BLK		   0x75					 		 /* дݴ */
#define	SD_ERR_WRITE_BLKNUMS       0x76				 	 		 /* дʱ,ҪдĿȷдĿһ */
#define SD_ERR_WRITE_PROTECT	   0x77					 		 /* ǵдشдλ */


/* ********************************************************************************************************************* */
/* ״̬ļģʽµĴ̼ļ״̬, VAR_DISK_STATUS */
#ifndef	DEF_DISK_UNKNOWN
#define	DEF_DISK_UNKNOWN		   0x00							 /* δʼ,δ֪״̬ */
#define	DEF_DISK_DISCONN		   0x01							 /* ûӻѾϿ */
#define	DEF_DISK_CONNECT		   0x02							 /* Ѿ,δʼ޷ʶô */
#define	DEF_DISK_MOUNTED		   0x03							 /* Ѿʼɹ,δļϵͳļϵͳ֧ */
#define	DEF_DISK_READY			   0x10						 	 /* Ѿ̵ļϵͳܹ֧ */
#define	DEF_DISK_OPEN_ROOT		   0x12							 /* Ѿ򿪸Ŀ¼,ʹúر,עFAT12/FAT16Ŀ¼ǹ̶ */
#define	DEF_DISK_OPEN_DIR		   0x13							 /* ѾĿ¼(ļ) */
#define	DEF_DISK_OPEN_FILE		   0x14							 /* Ѿļ */
#endif


/* ********************************************************************************************************************* */
/* ļϵͳö */
#ifndef	DEF_SECTOR_SIZE
#define	DEF_SECTOR_SIZE		       512							 /* U̻SDĬϵĴС */
#endif

#ifndef	DEF_WILDCARD_CHAR
#define	DEF_WILDCARD_CHAR	       0x2A							 /* ·ͨ '*' */
#define	DEF_SEPAR_CHAR1			   0x5C							 /* ·ķָ '\' */
#define	DEF_SEPAR_CHAR2			   0x2F							 /* ·ķָ '/' */
#define	DEF_FILE_YEAR			   2004							 /* Ĭļ: 2004 */
#define	DEF_FILE_MONTH			   1							 /* Ĭļ: 1 */
#define	DEF_FILE_DATE			   1							 /* Ĭļ: 1 */
#endif

#ifndef	ATTR_DIRECTORY

/* FATļĿ¼Ϣ */
typedef struct _FAT_DIR_INFO 
{
	UINT8	DIR_Name[11];										 /* 00H,ļ,11ֽ,㴦ո */
	UINT8	DIR_Attr;											 /* 0BH,ļ,ο˵ */
	UINT8	DIR_NTRes;											 /* 0CH */
	UINT8	DIR_CrtTimeTenth;									 /* 0DH,ļʱ,0.1뵥λ */
	UINT16	DIR_CrtTime;										 /* 0EH,ļʱ */
	UINT16	DIR_CrtDate;										 /* 10H,ļ */
	UINT16	DIR_LstAccDate;										 /* 12H,һδȡ */
	UINT16	DIR_FstClusHI;										 /* 14H */
	UINT16	DIR_WrtTime;										 /* 16H,ļ޸ʱ,οǰĺMAKE_FILE_TIME */
	UINT16	DIR_WrtDate;										 /* 18H,ļ޸,οǰĺMAKE_FILE_DATE */
	UINT16	DIR_FstClusLO;										 /* 1AH */
	UINT32	DIR_FileSize;										 /* 1CH,ļ */
} FAT_DIR_INFO, *P_FAT_DIR_INFO;								 /* 20H */


/* ļ */
#define ATTR_READ_ONLY			   0x01							 /* ļΪֻ */
#define ATTR_HIDDEN				   0x02					 	  	 /* ļΪ */
#define ATTR_SYSTEM				   0x04							 /* ļΪϵͳ */
#define ATTR_VOLUME_ID			   0x08							 /*  */
#define ATTR_DIRECTORY			   0x10							 /* Ŀ¼(ļ) */
#define ATTR_ARCHIVE			   0x20							 /* ļΪ浵 */
#define ATTR_LONG_NAME			   ( ATTR_READ_ONLY | ATTR_HIDDEN | ATTR_SYSTEM | ATTR_VOLUME_ID )	/* ļ */
#define ATTR_LONG_NAME_MASK		   ( ATTR_LONG_NAME | ATTR_DIRECTORY | ATTR_ARCHIVE )
/* ļ UINT8 */
/* bit0 bit1 bit2 bit3 bit4 bit5 bit6 bit7 */
/*  ֻ      ϵ      Ŀ      δ   */
/*        ͳ      ¼               */

/* ļʱ UINT16 */
/* Time = (Hour<<11) + (Minute<<5) + (Second>>1) */
#define MAKE_FILE_TIME( h, m, s )  ( (h<<11) + (m<<5) + (s>>1) ) /* ָʱļʱ */

/* ļ UINT16 */
/* Date = ((Year-1980)<<9) + (Month<<5) + Day */
#define MAKE_FILE_DATE( y, m, d )  ( ((y-1980)<<9) + (m<<5) + d )/* ָյļ */

#define LONE_NAME_MAX_CHAR		   (255*2)						 /* ļַ/ֽ */
#define LONG_NAME_PER_DIR		   (13*2)						 /* ļÿļĿ¼Ϣṹеַ/ֽ */

#endif

/* ********************************************************************************************************************* */
/* SCSIṹ */

#ifndef	SPC_CMD_INQUIRY12

/* SCSI */
#define SPC_CMD_INQUIRY			   0x12
#define SPC_CMD_READ_CAPACITY	   0x25
#define SPC_CMD_READ10			   0x28
#define SPC_CMD_WRITE10			   0x2A
#define SPC_CMD_TEST_READY		   0x00
#define SPC_CMD_REQUEST_SENSE	   0x03
#define SPC_CMD_MODESENSE6		   0x1A
#define SPC_CMD_MODESENSE10		   0x5A
#define SPC_CMD_START_STOP		   0x1B

/* BulkOnlyЭ */
typedef struct _BULK_ONLY_CBW 
{
	UINT32	CBW_Sig;
	UINT32	CBW_Tag;
	UINT8	CBW_DataLen0;										 /* 08H,: ݴ䳤,Чֵ048,ЧֵΪ033 */
	UINT8	CBW_DataLen1;
	UINT16	CBW_DataLen2;
	UINT8	CBW_Flag;											 /* 0CH,: ䷽ȱ־,λ7Ϊ1,λΪ0ݻû */
	UINT8	CBW_LUN;
	UINT8	CBW_CB_Len;											 /* 0EH,: ĳ,Чֵ116 */
	UINT8	CBW_CB_Buf[16];										 /* 0FH,: ,ûΪ16ֽ */
} BULK_ONLY_CBW, *P_BULK_ONLY_CBW;								 /* BulkOnlyЭ, CBWṹ */

/* INQUIRYķ */
typedef struct _INQUIRY_DATA 
{
	UINT8	DeviceType;											 /* 00H, 豸 */
	UINT8	RemovableMedia;										 /* 01H, λ7Ϊ1˵ƶ洢 */
	UINT8	Versions;											 /* 02H, Э汾 */
	UINT8	DataFormatAndEtc;									 /* 03H, ָݸʽ */
	UINT8	AdditionalLength;									 /* 04H, ݵĳ */
	UINT8	Reserved1;
	UINT8	Reserved2;
	UINT8	MiscFlag;											 /* 07H, һЩƱ־ */
	UINT8	VendorIdStr[8];										 /* 08H, Ϣ */
	UINT8	ProductIdStr[16];									 /* 10H, ƷϢ */
	UINT8	ProductRevStr[4];									 /* 20H, Ʒ汾 */
} INQUIRY_DATA, *P_INQUIRY_DATA;								 /* 24H */

/* REQUEST SENSEķ */
typedef struct _SENSE_DATA 
{
	UINT8	ErrorCode;											 /* 00H, 뼰Чλ */
	UINT8	SegmentNumber;
	UINT8	SenseKeyAndEtc;										 /* 02H,  */
	UINT8	Information0;
	UINT8	Information1;
	UINT8	Information2;
	UINT8	Information3;
	UINT8	AdditSenseLen;										 /* 07H, ݵĳ */
	UINT8	CmdSpecInfo[4];
	UINT8	AdditSenseCode;										 /* 0CH, Ӽ */
	UINT8	AddSenCodeQual;										 /* 0DH, ϸĸӼ */
	UINT8	FieldReplaUnit;
	UINT8	SenseKeySpec[3];
} SENSE_DATA, *P_SENSE_DATA;									 /* 12H */

#endif

/* ********************************************************************************************************************* */
/* ļģʽµṹ */

#ifndef	MAX_FILE_NAME_LEN
#define MAX_PATH_LEN			128								 /* ·,бָܷСԼ·00H */
#define MAX_FILE_NAME_LEN		128								 /* ·,бָܷСԼ·00H */

/* ݺ */
typedef union _CH378_CMD_DATA 
{
	struct 
	{
		UINT8  mBuffer[ MAX_PATH_LEN ];
	} Default;
	
	struct 
	{
		UINT32 mTotalSector;									 /* : ǰ߼̵(ܳ32λ,ֽǰ) */
		UINT32 mFreeSector;										 /* : ǰ߼̵ʣ(ܳ32λ,ֽǰ) */
		UINT8  mDiskFat;										 /* : ǰ߼̵FAT,1-FAT12,2-FAT16,3-FAT32 */
	} DiskQuery;												 /* CMD0H_DISK_QUERY, ѯϢ */

	struct 
	{
		UINT32 mDiskSizeSec;									 /* : ̵(ܳ32λ,ֽǰ) */
	} DiskCapacity;												 /* CMD0H_DISK_CAPACITY: ѯ */

	struct 
	{
		UINT8  mPathName[ MAX_PATH_LEN ];						 /* : ·: [̷,ð,б,Ŀ¼ļչ...,00H], ̷ðſʡ, "C:\DIR1.EXT\DIR2\FILENAME.EXT",00H */
	} Open;														 /* CMD0H_FILE_OPEN, ļ */

	struct 
	{
		UINT8  mUpdateFileSz;									 /* : Ƿļ, 0ֹ³ */
	} CLose;												 	 /* CMD1H_FILE_CLOSE: رյǰѾ򿪵ļ */

	struct 
	{
		UINT8  mPathName[ MAX_PATH_LEN ];						 /* : ·: [̷,ð,б,Ŀ¼ļչ...,00H], ̷ðſʡ, "C:\DIR1.EXT\DIR2\FILENAME.EXT",00H */
	} Create;													 /* CMD0H_FILE_CREATE, ½ļ,ļѾɾ½ */

	struct 
	{
		UINT8  mPathName[ MAX_PATH_LEN ];						 /* : ·: [̷,ð,б,Ŀ¼ļչ...,00H], ̷ðſʡ, "C:\DIR1.EXT\DIR2\FILENAME.EXT",00H */
	} Erase;													 /* CMD0H_FILE_ERASE, ɾļر */

	struct 
	{
		UINT32 mFileSize;										 /* : µļ,Ϊ0FFFFFFFFH޸, : ԭ */
		UINT16 mFileDate;										 /* : µļ,Ϊ0FFFFH޸, : ԭ */
		UINT16 mFileTime;										 /* : µļʱ,Ϊ0FFFFH޸, : ԭʱ */
		UINT8  mFileAttr;										 /* : µļ,Ϊ0FFH޸, : ԭ */
	} Modify;													 /* CMD0H_FILE_QUERY, ѯǰļϢ; CMD0H_FILE_MODIFY, ѯ޸ĵǰļϢ */

	union 
	{
		UINT32 mSectorOffset;									 /* : ƫ,Ϊλƫ(ܳ32λ,ֽǰ) */
		UINT32 mSectorLba;										 /* : ǰļָӦľ,0FFFFFFFFHѵļβ(ܳ32λ,ֽǰ) */
	} SectorLocate;												 /* CMD4H_SEC_LOCATE: Ϊλƶǰļָ */

	struct 
	{
		UINT8  mSectorCount;									 /* : ȡ(: ȡ) */
		UINT8  mReserved1;
		UINT8  mLbaCount;
		UINT8  mReserved2;
		PUINT8 mDataBuffer;										 /* : ǰַ */
	} SectorRead;												 /* CMD1H_SEC_READ: Ϊλӵǰλöȡݿ */

	struct 
	{
		UINT8  mSectorCount;									 /* : д(: д) */																 /*  */
		UINT8  mReserved1;
		UINT8  mLbaCount;
		UINT8  mReserved2;
		PUINT8 mDataBuffer;										 /* : ǰַ */
	} SectorWrite;												 /* CMD1H_SEC_WRITE: Ϊλڵǰλдݿ */

	union 
	{
		UINT32 mByteOffset;										 /* : ƫֽ,ֽΪλƫ(ܳ32λ,ֽǰ) */
		UINT32 mSectorLba;										 /* : ǰļָӦľ,0FFFFFFFFHѵļβ(ܳ32λ,ֽǰ) */
	} ByteLocate;												 /* CMD4H_BYTE_LOCATE: ֽΪλƶǰļָ */

	struct 
	{
		UINT16 mByteCount;										 /* : ȡֽ(ܳ16λ,ֽǰ) */
	} ByteRead;													 /* CMD2H_BYTE_READ: ֽΪλӵǰλöȡݿ */

	struct 
	{
		UINT16 mByteCount;										 /* : дֽ(ܳ16λ,ֽǰ) */
	} ByteWrite;												 /* CMD2H_BYTE_WRITE: ֽΪλǰλдݿ */
	
	struct 
	{
		UINT32 mStartSector;									 /* : LBAַ(ܳ32λ,ֽǰ) */
		UINT8  mSectorCount;									 /* : ȡ */
	} DiskRead;													 /* CMD5H_DISK_READ: USB洢ݿ(Ϊλ) */

	struct 
	{
		UINT32 mStartSector;									 /* : LBAַ(ܳ32λ,ֽǰ) */
		UINT8  mSectorCount;									 /* : д */
	} DiskWrite;												 /* CMD5H_DISK_WRITE: USB洢дݿ(Ϊλ) */

	INQUIRY_DATA DiskMountInq;									 /* : INQUIRYķ */
																 /* CMD0H_DISK_MOUNT: ʼ̲ԴǷ,״ִʱ */

	FAT_DIR_INFO OpenDirInfo;									 /* : öٵļĿ¼Ϣ */
																 /* CMD0H_FILE_OPEN: öļĿ¼(ļ) */

	FAT_DIR_INFO EnumDirInfo;									 /* : öٵļĿ¼Ϣ */
																 /* CMD0H_FILE_ENUM_GO: öļĿ¼(ļ) */

	BULK_ONLY_CBW DiskBocCbw;									 /* : CBWṹ */
																 /* CMD0H_DISK_BOC_CMD: USB洢ִBulkOnlyЭ */
	struct 
	{
		UINT8  mMaxLogicUnit;									 /* : USB洢߼Ԫ */
	} DiskMaxLun;												 /* CMD0H_DISK_MAX_LUN: ƴ-ȡUSB洢߼Ԫ */

	INQUIRY_DATA DiskInitInq;									 /* : INQUIRYķ */
																 /* CMD0H_DISK_INIT: ʼUSB洢 */

	INQUIRY_DATA DiskInqData;									 /* : INQUIRYķ */
																 /* CMD0H_DISK_INQUIRY: ѯUSB洢 */

	SENSE_DATA ReqSenseData;									 /* : REQUEST SENSEķ */
																 /* CMD0H_DISK_R_SENSE: USB洢 */
}CH378_CMD_DATA, *P_CH378_CMD_DATA;

#endif

/* ********************************************************************************************************************* */
/* ļģʽµļϵͳĵַ */

#ifndef	VAR_FILE_SIZE

/* 8λ/ֽڱ */
#define	VAR8_DEV_CONNECTSTATUS	   0x02                          /* ǰ豸״̬: 0--δ, 1--δʼ, 2--ʼɹ */
#define	VAR8_USB_DEV_SPEED	       0x03                          /* ǰӵUSB豸ٶ: 0--δ֪, 1--, 2--ȫ, 3-- */ 	
#define	VAR8_CMD_INT_STATUS		   0x0B							 /* CH378ǰִж״̬(Բжϵ) */
#define	VAR8_LAST_CMD     		   0x0C							 /* CH378յһ */
#define	VAR8_CMD_OP_STATUS		   0x0E							 /* CH378ǰִ״̬ */
#define	VAR8_SDO_INT_ENABLE        0x16							 /* SPIģʽǷʹSDOж֪ͨ־(0:ֹ, 1:ʹ) */
#define	VAR8_DISK_STATUS		   0x21							 /* ļģʽµĴ̼ļ״̬ */
#define	VAR8_DISK_FAT			   0x22							 /* ߼̵FAT־:1=FAT12,2=FAT16,3=FAT32 */
#define	VAR8_SEC_PER_CLUS		   0x23							 /* ߼̵ÿ */
#define	VAR8_DISK_SEC_LEN		   0x24							 /* ߼̵ÿС(һΪ512ֽ,U̿Ϊ1024,2048,4096) */
																 /* 9 = 512, 10 = 1024, 11 = 2048, 12 = 4096 */
/* 32λ/4ֽڱ */
#define	VAR32_DISK_CAP			   0x51							 /* ߼̵ */
#define	VAR32_DISK_SEC_SIZE	   	   0x52							 /* ߼̵ÿС(һΪ512ֽ,U̿Ϊ1024,2048,4096) */
#define	VAR32_SYSTEM_PARA	   	   0x55							 /* CH378ϵͳ */
#define  RB_WORK_MODE_SET0   	   ( 1 << 0 )					 /* λ1--0: ǰоƬӿģʽ( 00:δ֪; 01:8λ; 02:SPIӿ; 03:첽 ) */ 	
#define  RB_WORK_MODE_SET1   	   ( 1 << 1 )
#define  RB_AUTO_CHECK_CONNECT	   ( 1 << 2 )					 /* λ2CH378ԶUSB豸/SDӺͶϿʹ */
#define  RB_HOST_SD_UDISK	       ( 1 << 3 )			 		 /* λ3ģʽ0---USB洢豸1---SD */
#define  RB_USB_CONFIG	    	   ( 1 << 4 ) 					 /* λ4ʽUSB豸ӱ־ */

#define	VAR32_FILE_SIZE			   0x68							 /* ǰļĳ(ܳ32λ,ֽǰ) */
#define	VAR32_DSK_START_LBA		   0x70							 /* ߼̵ʼLBA(ܳ32λ,ֽǰ) */
#define	VAR32_DISK_ROOT			   0x71							 /* FAT16ΪĿ¼ռ,FAT32ΪĿ¼ʼغ(ܳ32λ,ֽǰ) */
#define	VAR32_DSK_DAT_START		   0x72							 /* ߼̵ʼLBA(ܳ32λ,ֽǰ) */
#define	VAR32_START_CLUSTER		   0x73							 /* ǰļĿ¼(ļ)ʼغ(ܳ32λ,ֽǰ) */
#define	VAR32_CURRENT_OFFSET	   0x74							 /* ǰļָ,ǰдλõֽƫ(ܳ32λ,ֽǰ) */
#define	VAR_FAT_DIR_LBA			   0x75							 /* ǰļĿ¼ϢڵLBAַ(ܳ32λ,ֽǰ) */
#define	VAR_FAT_OFFSET			   0x76							 /* ǰļĿ¼ϢƫƵַ(ܳ32λ,ֽǰ) */

#endif

/* ********************************************************************************************************************* */
/* USB */

/* USBİʶPID, ʽõ */
#ifndef	DEF_USB_PID_SETUP
#define	DEF_USB_PID_NULL		   0x00							 /* PID, δ */
#define	DEF_USB_PID_SOF		       0x05
#define	DEF_USB_PID_SETUP	       0x0D
#define	DEF_USB_PID_IN		       0x09
#define	DEF_USB_PID_OUT		  	   0x01
#define	DEF_USB_PID_ACK			   0x02
#define	DEF_USB_PID_NAK			   0x0A
#define	DEF_USB_PID_STALL		   0x0E
#define	DEF_USB_PID_DATA0		   0x03
#define	DEF_USB_PID_DATA1		   0x0B
#define	DEF_USB_PID_PRE			   0x0C
#endif

/* USB, ù̼ģʽõ */
#ifndef	DEF_USB_REQ_TYPE
#define	DEF_USB_REQ_READ		   0x80							 /* ƶ */
#define	DEF_USB_REQ_WRITE		   0x00						  	 /* д */
#define	DEF_USB_REQ_TYPE		   0x60							 /*  */
#define	DEF_USB_REQ_STAND		   0x00							 /* ׼ */
#define	DEF_USB_REQ_CLASS		   0x20						 	 /* 豸 */
#define	DEF_USB_REQ_VENDOR		   0x40							 /*  */
#define	DEF_USB_REQ_RESERVE		   0x60							 /*  */
#endif

/* USB׼豸, RequestTypeλ6λ5=00(Standard), ù̼ģʽõ */
#ifndef	DEF_USB_GET_DESCR
#define	DEF_USB_CLR_FEATURE	 	   0x01
#define	DEF_USB_SET_FEATURE		   0x03
#define	DEF_USB_GET_STATUS		   0x00
#define	DEF_USB_SET_ADDRESS		   0x05
#define	DEF_USB_GET_DESCR		   0x06
#define	DEF_USB_SET_DESCR		   0x07
#define	DEF_USB_GET_CONFIG		   0x08
#define	DEF_USB_SET_CONFIG		   0x09
#define	DEF_USB_GET_INTERF		   0x0A
#define	DEF_USB_SET_INTERF		   0x0B
#define	DEF_USB_SYNC_FRAME		   0x0C
#endif

/* ********************************************************************************************************************* */

#ifdef __cplusplus
}
#endif

#endif
