/********************************** (C) COPYRIGHT *******************************
* File Name          : PARA_SW.C
* Author             : MJX
* Version            : V1.20
* Date               : 2015/08/28
* Description        : CH378оƬ ģ8λӵӲ V1.2
*                      ṩI/Oӿӳ
*******************************************************************************/



/*******************************************************************************/
/* ͷļ */
#include "HAL.H"

/*******************************************************************************/
/* Ӳغ궨 */
/* еӲӷʽ(ʵӦõ·Բ޸弰ӳ) */
/* Ƭ    CH378оƬ
      P2.0                 A0
      P2.6                 CS#    ģĲֻCH378,ôCS#ֱӽӵ͵ƽ,ǿƬѡ
      P3.6                 WR#
      P3.7                 RD#
      P0(8λ˿)         D7-D0 */

sbit	CH378_A0		=		   P2^0;
sbit	CH378_CS		=		   P2^6;
sbit	CH378_WR		=		   P3^6;
sbit	CH378_RD		=		   P3^7;
#define	CH378_DATA_DAT_OUT( d )	   { P0 = d; }					 /* 򲢿 */
#define	CH378_DATA_DAT_IN( )	   ( P0 )						 /* Ӳ */
#define	CH378_DATA_DIR_OUT( )									 /* òڷΪ */
#define	CH378_DATA_DIR_IN( )	   { P0 = 0xFF; }				 /* òڷΪ */

#define CH378_INT_WIRE			   INT0							 /* ٶCH378INT#,δôҲͨѯ״̬˿ʵ */

/*******************************************************************************
* Function Name  : CH378_Port_Init
* Description    : CH378˿ڳʼ
*                  ʹͨI/OģⲢڶдʱ,Խгʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CH378_Port_Init( void ) 
{
	CH378_CS = 1;
	CH378_WR = 1;
	CH378_RD = 1;
	CH378_A0 = 0;
	CH378_DATA_DIR_IN( );  								 	  	 /* ò */
}

/*******************************************************************************
* Function Name  : mDelay0_5uS
* Description    : ʱ0.5΢
*                  ʱ0.5uS,ݵƬƵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void mDelay0_5uS( void )
{
}

#define	xEndCH378Cmd( )  										 /* CH378,SPIӿڷʽ */

/*******************************************************************************
* Function Name  : xReadCH378Status
* Description    : CH378״̬,ڲڷʽ
* Input          : None
* Output         : None
* Return         : ضȡ״̬
*******************************************************************************/
UINT8 xReadCH378Status( void )  
{
	UINT8  mData;

	CH378_DATA_DIR_IN( );  										 /* òڷΪ */
	CH378_A0 = 1;
	CH378_CS = 0;
	CH378_RD = 0;  												 /* Чź, CH378оƬ״̬˿ */

	/* ò,ʱ,CH378Ҫдȴ40nS,ǿҽ˴ִһָʱȷ㹻ʱ */
	CH378_CS = 0;  												 
	mData = CH378_DATA_DAT_IN( );  								 /* CH378Ĳ */
	CH378_RD = 1;  												 /* ЧĿź, ɲCH378оƬ */
	CH378_CS = 1;
	CH378_A0 = 0;
	return( mData );
}

/*******************************************************************************
* Function Name  : xWriteCH378Cmd
* Description    : CH378д
* Input          : mCmd---Ҫд뵽CH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Cmd( UINT8 mCmd ) 
{
	CH378_DATA_DAT_OUT( mCmd );  								 /* CH378Ĳ */
	CH378_DATA_DIR_OUT( );  									 /* òڷΪ */
	CH378_A0 = 1;
	CH378_CS = 0;
	CH378_WR = 0;  												 /* Чдź, дCH378оƬ˿ */		
	CH378_CS = 0;  												 /* ò,ʱ,CH378Ҫдȴ40nS */
	CH378_WR = 1;  												 /* ЧĿź, ɲCH378оƬ */
	CH378_CS = 1;
	CH378_A0 = 0;
	CH378_DATA_DIR_IN( );  										 /* ֹ */
/*	mDelay0_5uS( ); 
    mDelay0_5uS( ); 
    mDelay0_5uS( );*/  											 /* ʱ1.5uSȷдڴ1.5uS */
}

/*******************************************************************************
* Function Name  : xWriteCH378Data
* Description    : CH378д
* Input          : mData---Ҫд뵽CH378
* Output         : None
* Return         : None
*******************************************************************************/
void xWriteCH378Data( UINT8 mData )  
{
	CH378_DATA_DAT_OUT( mData );  								 /* CH378Ĳ */
	CH378_DATA_DIR_OUT( );  									 /* òڷΪ */
	CH378_A0 = 0;
	CH378_CS = 0;
	CH378_WR = 0;  												 /* Чдź, дCH378оƬݶ˿ */
	CH378_CS = 0;  												 /* ò,ʱ,CH378Ҫдȴ40nS */
	CH378_WR = 1; 	 											 /* ЧĿź, ɲCH378оƬ */
	CH378_CS = 1;
	CH378_DATA_DIR_IN( );  										 /* ֹ */
//	mDelay0_5uS( );  											 /* ȷдڴ0.6uS */
}

/*******************************************************************************
* Function Name  : xReadCH378Data
* Description    : CH378
* Input          : None
* Output         : None
* Return         : ضȡ
*******************************************************************************/
UINT8 xReadCH378Data( void )  
{
	UINT8  mData;

	CH378_DATA_DIR_IN( );  										 /* òڷΪ */
	CH378_A0 = 0;
	CH378_RD = 0;  												 /* Чź, CH378оƬݶ˿ */
	CH378_CS = 0;
	
	/* ò,ʱ,CH378Ҫдȴ40nS,ǿҽ˴ִһָʱȷ㹻ʱ */
	CH378_CS = 0;  
	mData = CH378_DATA_DAT_IN( );  								 /* CH378Ĳ */
	CH378_RD = 1;  												 /* ЧĿź, ɲCH378оƬ */
	CH378_CS = 1;
	return( mData );
}

/*******************************************************************************
* Function Name  : Query378Interrupt
* Description    : ѯCH378ж(INT#͵ƽ)
* Input          : None
* Output         : None
* Return         : ж״̬
*******************************************************************************/
UINT8 Query378Interrupt( void )
{
	/* CH378жֱӲѯж */
	/* δCH378жѯ״̬˿ */	
#ifdef	CH378_INT_WIRE

	if( CH378_INT_WIRE == 0x00 )
	{
		mDelayuS( 10 );
		if( CH378_INT_WIRE == 0x00 )
		{
			return( TRUE );
		}		
	}
	return( FALSE );  
//	return( CH378_INT_PIN_WIRE( ) ? FALSE : TRUE );  
#else
	return( xReadCH378Status( ) & PARA_STATE_INTB ? FALSE : TRUE );  
#endif
}

/*******************************************************************************
* Function Name  : mInitCH378Host
* Description    : ʼCH378
* Input          : None
* Output         : None
* Return         : ز״̬
*******************************************************************************/
UINT8 mInitCH378Host( void )  
{
	UINT8 i, res;

	/* CH378Ƿ */
	CH378_Port_Init( );  										 /* ӿӲʼ */
	xWriteCH378Cmd( CMD11_CHECK_EXIST );  						 /* ԵƬCH378֮ͨѶӿ */
	xWriteCH378Data( 0x65 );
	res = xReadCH378Data( );
	xEndCH378Cmd( );  											 /* ڷʽҪ */
	if( res != 0x9A ) 
	{
		/* ͨѶӿڲ,ԭ:ӿ쳣,豸Ӱ(ƬѡΨһ),ڲ,һֱڸλ,񲻹 */
		return( ERR_USB_UNKNOWN );  
	}

	/* CH378ģʽ */
	xWriteCH378Cmd( CMD11_SET_USB_MODE );  						 /* 豸USBģʽ */
//	xWriteCH378Data( 0x04 );									 /* SD */
	xWriteCH378Data( 0x07 );									 /* USB洢豸 */
	
	/* ȴģʽ,ڲSDҪ10mSʱ,ڲUSB豸Ҫ35mSʱ */	
	/* ڲģʽԶζȡж */
	for( i = 0; i < 10; i++ )
	{
		mDelaymS( 10 );											 
		res = xReadCH378Data( );
		if( res == CMD_RET_SUCCESS ) 
		{
			xEndCH378Cmd( );  									 /* ڷʽҪ */
			return( ERR_SUCCESS );
		}
	}
	xEndCH378Cmd( );  											 /* ڷʽҪ */
	return( ERR_USB_UNKNOWN );  						  	     /* ģʽ */
}
